global constant
	FALSE = 0,
	TRUE = not FALSE,
	FAIL = -1,

	STDIN  = 0,
	STDOUT = 1,
	STDERR = 2

global integer
		--OkayGlb is a variable that a routine can use to indicate success/failure.
		--Any routine using it must set the value. It remains set till reset.
		--False true means success and false means failure of a routine.
	OkayGlb

include file.e
include graphics.e

--===========================================================================--
----Console I/O---------------------------------------------

----Error/Debugging-----------------------------------------
global procedure ErrAbort(sequence Msg, integer ExitCode)
	puts(STDOUT,Msg & "\nAborting program\n")
	abort(ExitCode)
end procedure --ErrAbort


----File I/O------------------------------------------------
global function FileExists(sequence Spec)
	--If file/dir exists, TRUE, else FALSE
	return(atom(dir(Spec)) = FALSE)
end function --FileExists

global function GetTextFile(sequence FilSpc)
	--Read the contents of the file spec passed into a sequence.
	--Return the sequence. Default is {}.
	--Use GlbErr.
	integer fn
	object LineIn
	sequence InBuf
	InBuf = {}
	fn = open(FilSpc,"r")
	if fn = FAIL then
		OkayGlb = FALSE
	else
		OkayGlb = TRUE
		LineIn = gets(fn)
		while not atom(LineIn) do
			InBuf = append(InBuf,LineIn)
			LineIn = gets(fn)
		end while
		close(fn)
	end if
	return InBuf
end function --GetTextFile

global function PutTextFile(sequence FilSpc, sequence FilBuf)
	--Write the contents of sequence to file spec passed.
	--Return true on success, false on failure
	integer fn
	fn = open(FilSpc,"w")
	if fn = FAIL then
		return FALSE
	else
		for i = 1 to length(FilBuf) do
			puts(fn,FilBuf[i])
		end for
		close(fn)
		return TRUE
	end if
end function --PutTextFile

----General--------------------------------------------------------
global procedure Delay(atom Secs)
	atom t
	t = time()
	while time() < t + Secs do end while
end procedure --Delay

global procedure Beep()
	sound(400)
	Delay(0.1)
	sound(0)
end procedure --Beep

global procedure BeepErr()
	Beep()
	Delay(0.1)
	Beep()
end procedure --Beep

global procedure SysRunCap(sequence CmdLin)
	system("Run "&CmdLin&">&>%Temp\\Run.Cap",2)
end procedure --SysRun

global procedure SysErrCap(sequence CmdLin)
	system(CmdLin&">&>%Temp\\Err.Cap",2)
end procedure --SysErrCap

--===========================================================================--
OkayGlb = FALSE