include wildcard.e
include Rtcgen.e
include Rwrite.e
	--Rstrings.e
		--Rslice.e

with trace

constant
	VARINI = "VarIni"

integer
	KeyPos,
	Rtn

object
	VarIniSpc

sequence
	Cmd,
	Key,
	NotFoundMsg,
	Value,
	ValRead,
	VarIniBuf

--===========================================================================--
procedure Initialize()
	NotFoundMsg = "NOTFOUND"
	KeyPos = 0
end procedure --Initialize

procedure ParseCmdLin(sequence CmdLin)
	Cmd = upper(CmdLin[1])
	Key = CmdLin[2]
	if length(CmdLin) > 2 then Value = CmdLin[3] end if
end procedure --ParseCmdLin

--===========================================================================--
function GetKey(sequence Buf) --> seq
	return TrimSpace(LeftToChar(Buf,'='))
end function --GetKey

procedure FindKey()
	--Sets KeyPos if the Key is found
	--Return 0 if not found.
	sequence
		uBuf,
		uKey
	uBuf = upper(VarIniBuf)
	uKey = upper(Key)
	for i = 1 to length(uBuf) do
		if match(uKey,uBuf[i]) then
			if compare(uKey,GetKey(uBuf[i])) = 0 then
				KeyPos = i
				return
			end if
		end if
	end for
end procedure --FindKey

-------------------------------------------------------------------------------
function GetVal(sequence Buf)
	return TrimSpace(RightToChar(Buf,'='))
end function --GetVal

procedure ProcessCmd()
	--Delete
	if compare(Cmd,"DELETE") = 0 then
		if KeyPos > 0 then
			VarIniBuf = Delete(VarIniBuf,KeyPos)
			Rtn = PutTextFile(VarIniSpc,VarIniBuf)
		end if
	end if
	--DeleteAll
	if compare(Cmd,"DELETEALL") = 0 then
		while TRUE do
			FindKey()
			if KeyPos = 0 then exit end if
			VarIniBuf = Delete(VarIniBuf,KeyPos)
			KeyPos = 0
		end while
		Rtn = PutTextFile(VarIniSpc,VarIniBuf)
	end if
	--Read
	if compare(Cmd,"READ") = 0 then
		if KeyPos > 0 then
			ValRead = GetVal(VarIniBuf[KeyPos])
			puts(STDOUT,ValRead)
		else
			puts(STDOUT,NotFoundMsg)
		end if
	end if
	--Write
	if compare(Cmd,"WRITE") = 0 then
		if KeyPos > 0 then
			VarIniBuf[KeyPos] = Key&'='&Value&'\n'
		else
			VarIniBuf = append(VarIniBuf,Key&'='&Value&'\n')
		end if
		Rtn = PutTextFile(VarIniSpc,VarIniBuf)
	end if
end procedure --ProcessCmd

--===========================================================================--
--Initialize
global procedure Var(sequence CmdLin)
	Initialize()
	ParseCmdLin(CmdLin)
--Get the file spec for VarIni
	VarIniSpc = getenv(VARINI)
	if atom(VarIniSpc) then
		ErrAbort("Environment variable, "&VARINI&", does not exist",0)
	end if
--Get VarIni into a sequence
	VarIniBuf = GetTextFile(VarIniSpc)
	if not OkayGlb then
		ErrAbort("Could not open "&VarIniSpc,0)
	end if
--Find the pos of Key in the sequence
	if not find(Cmd,{"DELETEALL"}) then
		FindKey()
	end if
--Now I have enough info. Process the command passed.
	ProcessCmd()
end procedure --Var