include Var.e

sequence
	Cmd,
	CmdLin,
	Key,
	ValidCmds,
	Value

--===========================================================================--
procedure Usage()
	WritelnHi("USAGE: Var.exe [?] FileSpec Read|Write|Delete|DeleteAll Key [Value]")
	Writeln  ("Commands")
	Writeln  (" ?         Show this help screen")
	Writeln  (" Read      Read a key and put its value to STDOUT")
	Writeln  ("           If no key is found, NOTFOUND is the result")
	Writeln  (" Write     Write the Key passed with the Value passed")
	Writeln  (" Delete    Delete the Key passed")
	Writeln  (" DeleteAll Delete all occurrences of the Key passed")
	Writeln  ("Arguments")
	Writeln  (" Key       Key to use for all Commands")
	Writeln  (" Value     New Value for Key after Write command")
	Writeln  ("Examples")
	Writeln  (" Var.exe  Read   YourKey")
	Writeln  (" Var.exe  Write  YourKey    NewValue")
	Writeln  (" Var.exe  Write \"Your Key\" \"New Value\"")
	Writeln  (" Var.exe  Delete YourKey")
	Writeln  (" Var.exe  DeleteAll YourKey")
	Writeln  ("Var.exe version 1.1")
	Writeln  (" As shown in in a write example, use double quotes for any parameter")
	Writeln  (" that has a space in it. VARINI is a required environment variable.")
	Writeln  (" A file named Var.Ini in your TEMP directory is recommended. Var.Ini")
	Writeln  (" should be created by the Autoexec.bat at boot time and should have")
	Write  (" [Variables] as the first line (for compatibility with other programs).")

	Beep()
	abort(1)
end procedure --Usage

procedure Initialize()
	ValidCmds = {"DELETE","DELETEALL","READ","WRITE"}
	Cmd = ""
	Key = ""
	Value = ""
end procedure --Initialize

procedure ParseCmdLin()
	CmdLin = command_line()
	if length(CmdLin) > 2 then Cmd 		= TrimSpace(upper(CmdLin[3])) end if
	if length(CmdLin) > 3 then Key 		= TrimSpace(CmdLin[4]) end if
	if length(CmdLin) > 4 then Value 	= TrimSpace(CmdLin[5]) end if

	if not find(Cmd,ValidCmds) or	find('?',Cmd) then Usage() end if
	if find(Cmd,{"DELETE","DELETEALL","READ"}) then
		if length(CmdLin)<4 then Usage() end if
		if length(Key)=0 then Usage() end if
	end if
	if find(Cmd,{"WRITE"}) then
		if length(CmdLin)<5 then Usage() end if
		if length(Key)=0 then Usage() end if
	end if
end procedure --ParseCmdLin

--===========================================================================--
--Initialize
	Initialize()
	ParseCmdLin()
	Var({Cmd,Key,Value})